
//*************************************************************
// Nonlinear DSGE Model of the US
// including a Kimball agregator on both prices and wages
//   
//
// Moyen S. 
//
// December 01, 2007
//*************************************************************
// v3 Stefanes code without cap util and growth
// v5 add banking sector at arbitrariy fixed values (no difference to version3)
// v6 add banking with correct fixed values but xi=0 (no difference to version3)
// v7 add banking with correct fixed values for any xi (implies fixed investment wedge)
// v8 banking with variable values 
// v9 estimation
// v10 welfare and irf
// v10test gives the same results as our code if you turn of habits, capital adju and fix cost, use additive utility and use our TR estimate bank params too
// v12 distingiush between estimated TR and optimal TR

var

Q C K I  L pi W WTILD  PTILD
uc R     
Dp ZP1 ZP2 Dw ZW1 ZW2
ZP3 ZW3 
Dpl DpLkim DpK Lkim
Dwl DwLkim DwK Lkimw
WELFARE  
Y MC R_K 
SI SI1    
AP   
AW   
ucbis   
EE_A EE_B EE_G EE_L EE_I EE_Q pi_BAR EE_P EE_W EE_R EE_BB EE_XI  xi EE_W1
PIEobs Robs Yobs Cobs Iobs Lobs
Wobs  
E_Rma E_Pma E_Wma 
dYobs dCobs dIobs dWobs dLobs kobs
psi wc
dYobspres dCobspres dIobspres dWobspres Lobspres PIEobspres Robspres 
Rreal
Rnominal
Infl
ruc rreuc q k rd re e d l
onew o
budget Prof Prof_Cap
Rs xis sigs xs Xs subsidy
aux qx
 
;


varexo 

E_A 
E_B 
E_G 
E_I 
E_P 
E_W
E_R
E_XI
E_M
E_L
E_W1
E_Q 
//E_BB
//E_L 
;  
 
parameters 
alph 
phi_i delta sig_c h ccs cinvs gamma_w xi_w gamma_p xi_p 
sig_l r_dpi r_pi r_dy r_y rho rho_a rho_pb rho_b rho_g rho_l rho_i 
r_pie xie mup muw Abar  subvw  
LSS TCUSS GSS 
pbar
kkim kkimw ma_r corIC rho_p rho_w rho_r ma_p ma_w corGA rho_bb
deltaSS deltawSS 
czcapbis
ctrend
lbar
betta_rate
xiparam kt qt scrap fix subsi 
r_k r_pie1 r_y1 r_pie_est r_y_est
sigma_A sigma_B sigma_G sigma_I sigma_P sigma_W sigma_R sigma_Q rho_q sigma_xi rho_xi sigma_M sigma_L sigma_W1 rho_W1
X multip fixcost
;






// parameters
//not estimated: kkim kkimw delta muw GSS deltaSS deltawSS r_pie r_y 
//not used: ma_r ccs cinvs xie Abar subvw TCUSS czcapbis
//normalized: LSS
//auxiliary: epsiw
//model variations:  fix subsi X multip fixcost 

// dixit stiglitz
//kkim = 0;
//kkimw = 0;
// kimball (stefane)
//kkim =10;
//kkimw = 10;

deltawSS = 0; 
deltaSS = 0; 


GSS      =  0.18    ; // government shar in y
phi_i	 =	0;//5.0975	; // capital adjustment param
sig_c	 =	1.01	; // exponent consumption in utiliy
sig_l	 =	1	; // exponent on labor in utiliy
betta_rate=	0.745516824501302	; // real IR implied by beta
h	     =	0;//0.65	; // habit
xi_w	 =	0.64	; // wage stickyness 
xi_p	 =	0.6	; // price stickyness 
gamma_w	 =	1       ; // wage  indexation to past (vs SS)
gamma_p	 =	1   	; // price indexation to past (vs SS)
alph	 =	0.36	; // capital share
delta    =  0.025   ; // depreciation
muw      =  1.5;//1.05     ; //wage markup w=muw*w_cost              
mup	     =	1.2	; // price markup p=mup*mc
epsiw    =  muw/(muw-1); // auxiliary
TCUSS    =  1       ; // IRRELEVBANT
czcapbis =	0.44	; // IRRELEVANT
corIC	 =	0       ; // correlation Q and B shocks (inactive
corGA	 =	0       ; // correlation G and A shocks

r_pie	 =	0     ; // TR params
r_pie_est=	1.5     ; // TR params
rho	     =	0       ;
r_y	     =	0.0     ;
r_y_est  =	0.0     ;
r_dy	 =	0       ;
r_k      =  0       ;
r_pie1   =  0       ;
r_y1     =  0       ;
pbar	 =	1.03	; // SS inflation

ctrend	 =	0      ; // trendgrowth
lbar	 =	0       ; // SS (un)employment ???????????????????
LSS      =  1       ; // steady steat employment. the auxiliary L_BAR, the weight on labor in utility, is adjusted such that labor is 1 in SS.

rho_bb   =  0     ;  // persistence of shocks
rho_r	 =	0	;
rho_w	 =	0	;
rho_a	 =	0.979	;
rho_b	 =	0	;
rho_g	 =	0.96	;
rho_p	 =	0.	;
rho_i	 =	0.	;
rho_l	 =	0       ;
rho_q	 =	0       ;
rho_W1	 =	0       ;
sigma_A  = 0.21384;
sigma_B  =  0  ;
sigma_G  = 0.5940;
sigma_I  =  0  ;
sigma_P  =  0  ;
sigma_W  =  0    ;
sigma_R  =  0.1    ;
sigma_Q  =  0    ;
sigma_M  =  0;
sigma_L   = 0;
sigma_W1   = 0;
ma_p	 =	0	; // MA component in price shock
ma_w	 =	0	;

fact=25.1;

invrisk=0;

sigma_xi  =  0    ;
rho_xi  =  0    ;


sig=0;
w2=2;
scrap=0;
fix=1;
subsi=0;
xiparam=0.015;

%w1 = 1.2139809760813154;
%w2 = 0.41901880788496554;
%sig = 0.7999641345960105;
kt=.2;
qt=.985;
scrap=0.5;
fix=0;
global options;
options=optimset('Display','none','TolFun',1e-12,'TolX',1e-12);
CondW=1;
X=0;
multip=1;
fixcost=1;

////////////////////////////////////////////////////////////////////////
// WE: dixit stiglitz, no fixed cost, additive, muw
//kkim = 0;
//kkimw = 0;
muw      =  1.05;//1.05     ; //wage markup w=muw*w_cost              
//multip=0;
//fixcost=0;

// STEFANE:  kimball
kkim =10;
kkimw = 10;
//muw      =  1.5;   //wage markup w=muw*w_cost 
multip=1;
fixcost=1;
qt= 0.97918      ;
kt=    0.19727;
alph      	=	0.192344926987021	;
phi_i     	=	6.17065937456949	;
sig_c     	=	1.94661944905612	;
h         	=	0.729298687040132	;
gamma_w   	=	0.545390891363723	;
xi_w      	=	0.816432939413862	;
gamma_p   	=	0.227049313444297	;
xi_p      	=	0.573420023033146	;
sig_l     	=	2.00979927681765	;
rho       	=	0.836182227351902	;
rho_a     	=	0.949309043462200	;
rho_b     	=	0.176201353456767	;
rho_g     	=	0.982480488345660	;
rho_i     	=	0.653550529381114	;
mup       	=	1.48427616617941	;
pbar      	=	0.622583596378731	;
rho_p     	=	0.968083278500972	;
rho_w     	=	0.909564205153107	;
rho_r     	=	0.622297577769036	;
ma_p      	=	0.622075877837990	;
ma_w      	=	0.981964530655509	;
corGA     	=	2.25559860762065	;
ctrend    	=	0.450448066420906	;
lbar      	=	0.370562828724896	;
betta_rate	=	0.393829963583098	;
xiparam   	=	0.0156792620938824	;
kt        	=	0.185634662843970	;
qt        	=	0.987981254011238	;
scrap     	=	0.476777672936394	;
r_pie_est 	=	1.74667619803870	;
r_y_est   	=	0.0121583854170700	;
sigma_A   	=	0.373537043123849	;
sigma_B   	=	2.79467408929443	;
sigma_G   	=	2.12867630115551	;
sigma_I   	=	4.45866232136064	;
sigma_P   	=	0.0965368928140807	;
sigma_W   	=	0.475103042523399	;
sigma_R   	=	0.0987880932079133	;

model;
//# phi_y= 1*1/MCSS;
//# deltaSS = 1-phik/(1-kim*phik/(epsip*(1+kim))); 

#  AWSS = 1;
#  betta=1/(1+betta_rate/100);
#  sig=(1/betta) - kt*(1/betta) -   2 *kt *xiparam;
#  w1= ((1 - scrap + qt *scrap)* (-2* kt *(1/betta) - qt *(1/betta) + kt*qt *(1/betta) -     4 *kt *xiparam + 2*kt* qt* xiparam))/( qt *(-kt* (1/betta) - qt* (1/betta) + kt *qt *(1/betta) - 3* kt*xiparam + 2* kt *qt *xiparam));
#  w2= -((  2* kt *(1 - scrap + qt* scrap)* ((1/betta) + xiparam))/(  qt^2 *(-kt* (1/betta) - qt* (1/betta) + kt* qt* (1/betta) - 3 *kt *xiparam + 2* kt *qt* xiparam)));
#  epsip = mup/(mup-1);
#  epsiw = muw/(muw-1);          
#  kim = - kkim/epsip; 
#  kimw = - kkimw/epsiw;
#  phik = epsip*(1+kim)/(epsip*(1+kim)-1);
#  phikw = epsiw*(1+kimw)/(epsiw*(1+kimw)-1);
#  MCSS = (1-deltaSS)/phik*(1-kim*phik/(epsip*(1+kim)));
#  phi_y = (1-deltaSS)/MCSS;
#  czcap = czcapbis/(1-czcapbis);
#  gamma = 1/(1-mup*kim);
#  gammabis = 1/(1-muw*kimw);
#  dprodSS = 1;
#  pente = gamma*(1-xi_p)*(1-betta*dprodSS^(1-sig_c)*xi_p)/xi_p/(1+betta*dprodSS^(1-sig_c)*gamma_p);
#  pentew = gammabis*(1-xi_w)*(1-betta*dprodSS^(1-sig_c)*xi_w)/xi_w/(1+betta*dprodSS^(1-sig_c));
#  RSS = 1/betta*dprodSS^(sig_c)-1;
#  R_KSS = 1/betta*dprodSS^(sig_c) -(1-delta)+xiparam*steady_state(k);
#  WSS = (MCSS*R_KSS^(-alph)*alph^alph*(1-alph)^(1-alph))^(1/(1-alph));
#  WTILDSS = WSS; 
#  DwSS = 1;  
#  KSS = alph/(1-alph)*WSS/R_KSS*LSS/DwSS*dprodSS;
#  ISS = (1-(1-delta)/dprodSS)*KSS;
#  YSS = (KSS/dprodSS)^alph*(LSS/DwSS)^(1-alph)/phi_y^fixcost;
#  CSS = YSS - ISS - GSS*YSS;
#  L_BAR = ((1-deltawSS)*WSS/phikw*(1-kimw*phikw/(epsiw*(1+kimw)))*LSS^(-sig_l)/(CSS - h*CSS/dprodSS)*(1-betta*h*dprodSS^(-sig_c)))*multip+(1-multip)*(WSS/phikw*LSS^(-sig_l)*((CSS - h*CSS)^(-sig_c)*(1-betta*h)));
#  ucbisSS = (CSS - h*CSS/dprodSS)^(-sig_c)*(exp(L_BAR*(sig_c-1)/(1+sig_l)*LSS^(1+sig_l)))^multip;
#  ucSS =(1-betta*h*dprodSS^(-sig_c))*ucbisSS;
#  ZP1SS = ucSS*MCSS*YSS/(1-betta*xi_p*dprodSS^(1-sig_c));
#  ZP2SS = (1-deltaSS)*ucSS*YSS/(1-betta*xi_p*dprodSS^(1-sig_c));
#  ZP3SS = (1-deltaSS)*ucSS*YSS/(1-betta*xi_p*dprodSS^(1-sig_c));
#  ZW1SS = L_BAR*LSS^(1+sig_l)*WSS^(epsiw*(1+kimw))/(1-betta*xi_w*dprodSS^(1-sig_c))*((CSS - h*CSS/dprodSS)^(1-sig_c)*exp(L_BAR*(sig_c-1)/(1+sig_l)*LSS^(1+sig_l)));
#  ZW2SS = (1-deltawSS)*ucSS*LSS*WSS^(epsiw*(1+kimw))/(1-betta*xi_w*AWSS^(epsiw*(1+kimw)-1)*dprodSS^(1-sig_c));
#  ZW3SS = (1-deltawSS)*ucSS*LSS/(1-betta*xi_w*dprodSS^(1-sig_c));
#  WELFARESS = multip*(((CSS*(1+X) - h*CSS*(1+X)/dprodSS)^(1-sig_c)/(1-sig_c)*exp(L_BAR*(sig_c-1)/(1+sig_l)*LSS^(1+sig_l)))/(1- betta*dprodSS^(1-sig_c)))+
               (1-multip)*(((CSS*(1+X) - h*CSS*(1+X)/dprodSS)^(1-sig_c)/(1-sig_c)-(L_BAR/(1+sig_l)*LSS^(1+sig_l)))/(1- betta*dprodSS^(1-sig_c)));

WELFARE = multip*     (exp(EE_B)*(C *(1+X)- h*C(-1)*(1+X))^(1-sig_c)/(1-sig_c)*exp(exp(-EE_L)*L_BAR*(sig_c-1)/(1+sig_l)*L^(1+sig_l))+ betta * WELFARE(1) )+
          (1-multip)* (exp(EE_B)*(C *(1+X)- h*C(-1)*(1+X))^(1-sig_c)/(1-sig_c)-exp(-EE_L)*L_BAR/(1+sig_l)*L^(1+sig_l)+ betta * WELFARE(1) );
psi=(WELFARE/WELFARESS)^(1/(1-sig_c))-1;
wc = psi*100;

       
// Adjunct variables 

 
SI = phi_i/2*(I/I(-1)-1)^2;  // inv adj

SI1 = phi_i*(I/I(-1)-1); // derivapive

AP = (1+pi)*(1+pi(-1))^(-gamma_p) * (1+pi_BAR)^(gamma_p-1); // auxil for price spickyness

AW = (1+pi)*(1+pi(-1))^(-gamma_w) * (1+pi_BAR)^(gamma_w-1); // for wages

MC = (R_K)^alph*W^(1-alph)/(alph^alph*(1-alph)^(1-alph))*exp(-EE_A);

Y = C + I + GSS*YSS*exp(EE_G);

ucbis = exp(EE_B)*(C - h*C(-1))^(-sig_c)*(exp(exp(-EE_L)*L_BAR*(sig_c-1)/(1+sig_l)*L^(1+sig_l)))^multip;

uc= uc(1)/(1+pi(1))*betta*(1+R)*exp(EE_BB)  ;                                                                       

uc = ucbis- betta*h*ucbis(1); 

//auxils
ruc                           = uc/(1+pi);
rreuc                         = re*uc/(1+pi);

budget=C  + d + e +GSS*YSS*exp(EE_G)   -( L/DwK*W + Prof + Prof_Cap + e(-1)*xi
+ d(-1)*(rd(-1)/(1+pi)*qx +(1-qx)*sig/(1-k(-1)+min(sig==0,k==1)) ) + e(-1)*(re/(1+pi)*qx-xi)) ;
Prof_Cap    = Q*onew-I; 
Prof    = Y-R_K*K-W*L/DwK;        


//HH
ruc(+1)*(1+R)*exp(EE_BB)      = (rreuc(+1)*q  - uc(+1)*xi)*exp(EE_Q);  
ruc(+1)*(1+R)*exp(EE_BB)      = (q*ruc(+1)*rd+ (1-q)*sig/(1-k+min(sig==0,k==1))*uc(+1))*exp(EE_Q); 

//bank
Rs     = ruc(+1)*(1+R)*exp(EE_BB)/exp(EE_Q);
xis    = uc(+1)*xi;
Xs     = 0;
sigs   = uc(+1)*sig;
xs     = 1;

e      = l*k;
d      = l*(1-k);
k = (fix==0)*((Rs - sigs*xs)/(Rs + 2* xis))
  + (fix==1)*steady_state(k); 

//q = (fix==0)*((((w1*exp(EE_W1))*(w2*(Rs-sigs*xs)*(Rs+2*xis)+(w2*(Rs-sigs*xs)*(Rs+2*xis)*(2*(w1*exp(EE_W1))*sigs*(Rs+xis)+w2*(Rs-sigs*xs)*(Rs+2*xis)))^.5+2^.5*Rs*(((Rs-sigs*xs)*((w1*exp(EE_W1))*w2*sigs*(Rs+xis)+w2^2*(Rs-sigs*xs)*(Rs+2*xis)+(w2^3*(Rs-sigs*xs)*(Rs+2*xis)*(2*(w1*exp(EE_W1))*sigs*(Rs+xis)+w2*(Rs-sigs*xs)*(Rs+2*xis)))^.5))/(Rs+2*xis))^.5))/(2*w2*((w1*exp(EE_W1))*sigs*(Rs+xis)+w2*(Rs-sigs*xs)*(Rs+2*xis)+(w2*(Rs-sigs*xs)*(Rs+2*xis)*(2*(w1*exp(EE_W1))*sigs*(Rs+xis)+w2*(Rs-sigs*xs)*(Rs+2*xis)))^.5))))
q = (fix==0)*(-Rs+sigs+(w2*(Rs-sigs)*(Rs+2*xis)*(2*(w1*exp(EE_W1))*sigs*(Rs+xis)+w2*(Rs-sigs)*(Rs+2*xis)))^.5/(w2*(Rs+2*xis)))/sigs
  + (fix==1)*steady_state(q); 

(1+pi)*((w1*exp(EE_W1)) - w2/2*q(-1))*(R_K+(1-delta)*Q)/Q(-1)+subsidy*pi=              rd(-1)*(1-k(-1)) + re*k(-1)+ (1-qx)*(sig-scrap*(R_K+(1-delta)*Q)/Q(-1))/(qx)*(1+pi)   ;
subsidy=(xi*k(-1)-xi*steady_state(k))/qx*subsi;


// CAPITAL PRODUCER 
K           = (qx*((w1*exp(EE_W1))-q(-1)*w2/2)+(1- qx)*scrap)*o(-1)  ;

onew*exp(EE_I)= o - (1-delta)*K;                                                                    
o*Q         = l; 
I*(1-SI)=onew; 
qx=q(-1);    

xi = xiparam *exp(EE_XI);                                                                  

//Q = exp(EE_Q)* betta*uc(1)/uc*(Q(1)*(1-delta)+R_K(1));                            

//K = (1-delta)*K(-1)+(1 - SI)*I*exp(EE_I);    
                                                           

Q*(1 - SI - I/I(-1)*SI1)*exp(EE_I) + betta*Q(1)*uc(1)/uc*SI1(1)*(I(1)/I)^2*exp(EE_I(1)) = 1;               

L/DwK*W=(1-alph)/alph*(R_K*K);                                                               

PTILD = phik*ZP1/ZP2 +kim*phik/(epsip*(1+kim))*PTILD^(1+epsip*(1+kim))*ZP3/ZP2;                                                                       

ZP1 = uc*MC*Y*Lkim^(epsip*(1+kim))+ betta*xi_p*AP(1)^(epsip*(1+kim))*ZP1(1);                                               

ZP2 = (1-deltaSS)*exp(EE_P)*uc*Y*Lkim^(epsip*(1+kim))+ betta*xi_p*AP(1)^(epsip*(1+kim)-1)*ZP2(1);                                                         

ZP3 = (1-deltaSS)*exp(EE_P)*uc*Y+ betta*xi_p*AP(1)^(-1)*ZP3(1);

//ZP2       = uc*MC*Y + xi_p * betta *  ZP2(+1)/((1+pi(+1))^(-epsip))*((1+pi)^1)^(-epsip) ;
//ZP1       = uc *PTILD*Y + xi_p * betta * ZP1(+1)/((1+pi(+1))^(1-epsip)*PTILD(+1))*((1+pi)^1)^(1-epsip)*(PTILD);
//epsip*ZP2 = (epsip-1)*ZP1;
//ZP3       = 0;

1/(1+kim)*Lkim+(kim/(1+kim))*Dpl = 1;                                               

DpK = 1/(1+kim)*Dp*DpLkim^(epsip*(1+kim)/(1-epsip*(1+kim)))+ kim/(1+kim);

Dp = (1-xi_p)*(PTILD)^(-epsip*(1+kim)) + xi_p*Dp(-1)*AP^(epsip*(1+kim));      // price dispersion                              
 
DpLkim = (1-xi_p)*(PTILD)^(1-epsip*(1+kim)) + xi_p*DpLkim(-1)*AP^(epsip*(1+kim)-1);

Dpl = (1-xi_p)*PTILD + xi_p*Dpl(-1)*AP^(-1);

Lkim^(1-epsip*(1+kim)) = DpLkim;

//PIEobs = gamma_p/(1+betta*gamma_p)*PIEobs(-1) +  betta/(1+betta*gamma_p)*PIEobs(1)
//        + pente*100*log(MC/MCSS);

//44
ZW1 = multip     * (exp(EE_B)*exp(-EE_L)*L_BAR*L^(1+sig_l)*W^(epsiw*(1+kimw))*((C - h*C(-1))^(1-sig_c) *exp(exp(-EE_L)*L_BAR*(sig_c-1)/(1+sig_l)*L^(1+sig_l)))*Lkimw^(epsiw*(1+kimw))  + betta*xi_w*AW(1)^(epsiw*(1+kimw))*ZW1(1))+
      (1-multip) * (exp(EE_B)*exp(-EE_L)*L_BAR*(W/WTILD)^(epsiw*(1+sig_l))*(L/DwK)^(1+sig_l)+betta*xi_w*(((1+pi)^(gamma_w) *(1+pi_BAR)^(1-gamma_w))/(1+pi(+1)))^(-epsiw*(1+sig_l))*(WTILD(+1)/WTILD)^(epsiw*(1+sig_l))*ZW1(+1));
ZW2 = multip     * ((1-deltawSS)*exp(EE_W)*uc*L*W^(epsiw*(1+kimw))*Lkimw^(epsiw*(1+kimw)) + betta*xi_w * AW(1)^(epsiw*(1+kimw)-1)*ZW2(1)) +
      (1-multip);
ZW3 = multip     * ((1-deltawSS)*exp(EE_W)*uc*L+ betta*xi_w*AW(1)^(-1)*ZW3(1)) +
      (1-multip);   
0   = multip     * ((phikw*ZW1/ZW2 +kimw*phikw/(epsiw*(1+kimw))*WTILD^(1+epsiw*(1+kimw))*ZW3/ZW2)-WTILD)+
      (1-multip) * (((epsiw-1)/epsiw*WTILD^(1-epsiw)*uc*W^epsiw*(L/DwK) + betta*xi_w*(((1+pi)^(gamma_w) *(1+pi_BAR)^(1-gamma_w))/(1+pi(+1)))^(1-epsiw)* (WTILD(+1)/WTILD)^(epsiw-1)*ZW1(+1))-ZW1);                                                                       

  
aux=q*((w1*exp(EE_W1))-w2/2*q)+scrap*(1-q)-1;

1/(1+kimw)*Lkimw+(kimw/(1+kimw))*Dwl = 1;

DwLkim = (1-xi_w)*(WTILD)^(1-epsiw*(1+kimw))*(W)^(epsiw*(1+kimw)-1) + xi_w*DwLkim(-1)*(W/W(-1))^(epsiw*(1+kimw)-1)*AW^(epsiw*(1+kimw)-1);

Dwl = (1-xi_w)*WTILD/W + xi_w*Dwl(-1)*W(-1)/W*AW^(-1);

Lkimw^(1-epsiw*(1+kimw)) = DwLkim;


DwK = 1/(1+kimw)*Dw*DwLkim^(epsiw*(1+kimw)/(1-epsiw*(1+kimw)))+ kimw/(1+kimw);

Dw = (1-xi_w)*W^(epsiw*(1+kimw))*(WTILD)^(-epsiw*(1+kimw))
      + xi_w*Dw(-1)*(W/W(-1))^(epsiw*(1+kimw))*AW^(epsiw*(1+kimw));  

DpK*Y = (K)^alph*(L/DwK)^(1-alph)*exp(EE_A)-(phi_y-1)*YSS*fixcost ;                               

PIEobs = 100*pi;          
Robs = 100*R;
Yobs = 100*log(Y/YSS);
Cobs = 100*log(C/CSS);
Iobs = 100*log(I/ISS);
Lobs = 100*log(L/LSS)+lbar;
Wobs = 100*log(W/WSS);

dYobs = 100*log(Y/Y(-1))+ctrend;
dCobs = 100*log(C/C(-1))+ctrend;
dIobs = 100*log(I/I(-1))+ctrend;
dWobs = 100*log(W/W(-1))+ctrend;
dLobs = 100*log(L/L(-1));

dYobspres = 100*log(Y/Y(-1));
dCobspres = 100*log(C/C(-1));
dIobspres = 100*log(I/I(-1));
dWobspres = 100*log(W/W(-1));
Lobspres = 100*log(L/LSS);
PIEobspres = 100*pi-pbar;          
Robspres = 100*R - (100*(1+RSS)*(1+pbar/100)-100);
kobs = 100*k +sigma_M*E_M ;


Rreal=(R+1)/(1+pi(+1));
Rnominal=R+1;
Infl=1+pi;
//Eobs = 0.5*Eobs(-1) + 0.5*Eobs(1) + (1-xie)*(1-betta*xie)/(xie)*(Lobs - Eobs);

// shocks

pi_BAR = pbar/100 ;// E_pi_BAR/100 
EE_A = rho_a*EE_A(-1) + E_A/100*sigma_A;
EE_B = rho_b*EE_B(-1) + E_B/100*sigma_B ;
EE_G = rho_g*EE_G(-1) + E_G/100*sigma_G + corGA* E_A/100*sigma_A;
EE_L = rho_l*EE_L(-1) + E_L/100*sigma_L ;
EE_I = rho_i*EE_I(-1) + E_I/100*sigma_I ;
EE_P = rho_p*EE_P(-1) + E_P/100/pente*sigma_P - ma_p*E_Pma(-1)/100/pente;// /(((1-xi_p)*(1-betta*xi_p)/(xi_p))) ;
EE_Q = rho_q*EE_Q(-1)+ E_Q/100*sigma_Q ;//+ corIC*EE_B + E_Q/100*sigma_Q ;
EE_W = rho_w*EE_W(-1) + E_W/100/pentew*sigma_W-ma_w*E_Wma(-1)/100/pentew ; 
EE_R = rho_r *EE_R(-1) + E_R*sigma_R ;//- ma_r*E_Rma;
EE_BB = 0*EE_BB(-1);// + E_BB/100*sigma_BB ;
EE_XI = rho_xi *EE_XI(-1) + E_XI*sigma_xi ;// 
EE_W1 = rho_W1 *EE_W1(-1) + E_W1*sigma_W1 ;// 



// MP

Robs - 100*(1+RSS)*(1+pbar/100)+100= (1-rho)*(r_pie_est*(PIEobs-pbar)+r_y_est*(Yobs))
                                     +(r_pie*(PIEobs-pbar)+r_y*(Yobs)+r_k*100*log(k/steady_state(k))+r_pie1*(PIEobs(+1)-pbar)+r_y1*Yobs(+1))
              +rho*(Robs(-1) - 100*(1+RSS)*(1+pbar/100)+100)
              -EE_R;
//(1+R)   = (1+R(-1))^(rho)*((1+pbar/100)/betta)*((1+pi)/(1+pbar/100))^r_pie;



E_Rma = 0;//+E_R;
E_Pma = E_P*sigma_P;
E_Wma = E_W*sigma_W;


end;

steady_state_model;
  AWSS_=1;
  betta_=1/(1+betta_rate/100);
  epsip_ = mup/(mup-1);
  epsiw_= muw/(muw-1);
  kim_ = - kkim/epsip_; 
  kimw_ = - kkimw/epsiw_;
  phik_ = epsip_*(1+kim_)/(epsip_*(1+kim_)-1);
  phikw_ = epsiw_*(1+kimw_)/(epsiw_*(1+kimw_)-1);
  MCSS_ = (1-deltaSS)/phik_*(1-kim_*phik_/(epsip_*(1+kim_)));
  phi_y_ = (1-deltaSS)/MCSS_;
  czcap_ = czcapbis/(1-czcapbis);
  gamma_ = 1/(1-mup*kim_);
  gammabis_ = 1/(1-muw*kimw_);
  dprodSS_ = 1;
  pente_ = gamma_*(1-xi_p)*(1-betta_*dprodSS_^(1-sig_c)*xi_p)/xi_p/(1+betta_*dprodSS_^(1-sig_c)*gamma_p);
  pentew_ = gammabis_*(1-xi_w)*(1-betta_*dprodSS_^(1-sig_c)*xi_w)/xi_w/(1+betta_*dprodSS_^(1-sig_c));
  RSS_ = 1/betta_*dprodSS_^(sig_c)-1;
RR=(1+RSS_);
sig_=RR - kt*RR -   2 *kt *xiparam;
w1_= ((1 - scrap + qt *scrap)* (-2* kt *RR - qt *RR + kt*qt *RR -     4 *kt *xiparam + 2*kt* qt* xiparam))/( qt *(-kt* RR - qt* RR + kt *qt *RR - 3* kt*xiparam + 2* kt *qt *xiparam));
w2_= -((  2* kt *(1 - scrap + qt* scrap)* (RR + xiparam))/(  qt^2 *(-kt* RR - qt* RR + kt* qt* RR - 3 *kt *xiparam + 2* kt *qt* xiparam)));
k = (RR - sig_)/(RR + 2* xiparam);
 
  R_KSS_ = 1/betta_*dprodSS_^(sig_c) -(1-delta)+xiparam*k;
  WSS_ = (MCSS_*R_KSS_^(-alph)*alph^alph*(1-alph)^(1-alph))^(1/(1-alph));
  WTILDSS_ = WSS_; 
  DwSS_ = 1;  
  KSS_ = alph/(1-alph)*WSS_/R_KSS_*LSS/DwSS_*dprodSS_;
  ISS_ = (1-(1-delta)/dprodSS_)*KSS_;
  YSS_ = (KSS_/dprodSS_)^alph*(LSS/DwSS_)^(1-alph)/phi_y_^fixcost;
  CSS_ = YSS_ - ISS_ - GSS*YSS_;
  L_BAR_ = multip*((1-deltawSS)*WSS_/phikw_*(1-kimw_*phikw_/(epsiw_*(1+kimw_)))*LSS^(-sig_l)/(CSS_ - h*CSS_/dprodSS_)*(1-betta_*h*dprodSS_^(-sig_c)))+(1-multip)* (WSS_/phikw_*LSS^(-sig_l)*((CSS_ - h*CSS_)^(-sig_c)*(1-betta_*h)));
 UCbisSS_ = (CSS_ - h*CSS_/dprodSS_)^(-sig_c)*(exp(L_BAR_*(sig_c-1)/(1+sig_l)*LSS^(1+sig_l)))^multip;
  UCSS_ = (1-betta_*h*dprodSS_^(-sig_c))*UCbisSS_;
  ZP1SS_ = UCSS_*MCSS_*YSS_/(1-betta_*xi_p*dprodSS_^(1-sig_c));
  ZP2SS_ = (1-deltaSS)*UCSS_*YSS_/(1-betta_*xi_p*dprodSS_^(1-sig_c));
  ZP3SS_ = (1-deltaSS)*UCSS_*YSS_/(1-betta_*xi_p*dprodSS_^(1-sig_c));
  ZW1SS_ = L_BAR_*LSS^(1+sig_l)*WSS_^(epsiw_*(1+kimw_))/(1-betta_*xi_w*dprodSS_^(1-sig_c))*((CSS_ - h*CSS_/dprodSS_)^(1-sig_c)*exp(L_BAR_*(sig_c-1)/(1+sig_l)*LSS^(1+sig_l)));
  ZW2SS_ = (1-deltawSS)*UCSS_*LSS*WSS_^(epsiw_*(1+kimw_))/(1-betta_*xi_w*dprodSS_^(1-sig_c));
  ZW3SS_ = (1-deltawSS)*UCSS_*LSS/(1-betta_*xi_w*dprodSS_^(1-sig_c));
  WELFARESS_ = multip*(((CSS_*(1+X) - h*CSS_*(1+X)/dprodSS_)^(1-sig_c)/(1-sig_c)*exp(L_BAR_*(sig_c-1)/(1+sig_l)*LSS^(1+sig_l)))/(1- betta_*dprodSS_^(1-sig_c)))+
               (1-multip)*(((CSS_*(1+X) - h*CSS_*(1+X)/dprodSS_)^(1-sig_c)/(1-sig_c)-(L_BAR_/(1+sig_l)*LSS^(1+sig_l)))/(1- betta_*dprodSS_^(1-sig_c)));
  ATCUSS_ = 1/czcap_*R_KSS_*(exp(czcap_*(TCUSS-1))-1);
  ATCU1SS_ = R_KSS_*exp(czcap_*(TCUSS-1));
  UL_=((CSS_ - h*CSS_/dprodSS_)^(1-sig_c)*exp(L_BAR_*(sig_c-1)/(1+sig_l)*LSS^(1+sig_l)))^multip*L_BAR_*LSS^sig_l;
  test_=UL_/UCSS_*phikw_-WSS_;

R=(1+RSS_)*(1+pbar/100)-1;
TCU = 1 ;
R_K = R_KSS_;
Q = 1 ;
C = CSS_ ;
K = KSS_;
I = ISS_ ;
Y = YSS_ ;
L = LSS ;
pi = pbar/100 ;
W = WSS_ ;
uc = UCSS_ ;
MC = MCSS_;
ucbis = UCbisSS_;
Dp = 1;
DpK = 1;
Dpl = 1;
DpLkim = 1;
Lkim = 1;
DwK = 1;
Dwl = 1;
DwLkim = 1;
Lkimw = 1;
ZP1 = ZP1SS_;
ZP2 = ZP2SS_;
ZP3 = ZP3SS_; 

WTILD = WTILDSS_;

Dw = DwSS_ ;
ZW1 =  multip*ZW1SS_+(1-multip)* L_BAR_*(WTILD/W)^(-epsiw_*(1+sig_l))*(L/DwK)^(1+sig_l)  /  (1-betta_*xi_w*((1+pi)^(1-1))^(-epsiw_*(1+sig_l)));
ZW2 =  (1-multip)+multip*ZW2SS_;
ZW3 =  (1-multip)+multip*ZW3SS_;
AP = 1;
AW = AWSS_;
WELFARE = WELFARESS_;
EE_A = 0;
EE_B = 0;
EE_G = 0;
EE_L = 0;
EE_I = 0; 
EE_P = 0;
EE_Q = 0;
EE_W = 0;
EE_R = 0; 
EE_XI = 0; 
pi_BAR = pbar/100;
SI = 0;
SI1 = 0;
Yobs = 0;
YFobs=0;
Cobs = 0;
Iobs = 0;
PTILD = 1;
Wobs=0;
PIEWobs=pbar + 100*log(dprodSS_);
E_Rma = 0;
E_Pma = 0;
E_Wma = 0;
SIF= 0; SI1F= 0; ATCUF= 0;
dYobs= ctrend; 
dCobs=  ctrend;
dIobs=  ctrend;
dWobs=  ctrend;
Lobs = lbar;
PIEobs = pbar; 
Robs = 100*(1+RSS_)*(1+pbar/100)-100;

dLobs= 0; 
kobs = 100*k;
dprod = dprodSS_;
EE_BB = 0;
psi=0;
wc=0;
dYobspres = 0; dCobspres = 0; dIobspres = 0; dWobspres = 0; Lobspres = 0; PIEobspres = 0; Robspres = 0; 

q = ((w1_* (w2_* (RR - sig_)* (RR + 2 *xiparam) + (     w2_ *(RR - sig_) *(RR + 2 *xiparam) *(2* w1_* sig_ *(RR + xiparam) +         w2_ *(RR - sig_) *(RR + 2* xiparam)))^.5 +      2^.5 *RR *(((RR - sig_) *(w1_* w2_ *sig_* (RR + xiparam) +          w2_^2 *(RR - sig_)* (RR + 2 *xiparam) + (         w2_^3* (RR - sig_) *(RR + 2* xiparam)* (2* w1_* sig_* (RR + xiparam) +             w2_ *(RR - sig_) *(RR + 2 *xiparam)))^.5))/(      RR + 2* xiparam))^.5))/(2 *w2_* (w1_* sig_* (RR + xiparam) +      w2_ *(RR - sig_) *(RR + 2 *xiparam) + (     w2_ *(RR - sig_)* (RR + 2* xiparam) *(2* w1_* sig_* (RR + xiparam) +         w2_ *(RR - sig_)* (RR + 2* xiparam)))^.5)));

xi = xiparam;

re         = (1+R +xi*(1+pi) )/q ;
rd         =(1+R-(1-q)*sig_*(1+pi)/(1-k))/q;
ruc                           = uc/(1+pi);
rreuc                         = re*uc/(1+pi);

onew=I*(1-SI);
o=onew +(1-delta)*K     ;                                                                    
l=o; 
e=k*l;
d=(1-k)*l;
Prof_Cap=0;
Prof    = Y-R_K*K-W*L/DwK;        
budget=0;
Rs     = ruc*(1+R);
xis    = uc*xi;
Xs     = 0;
sigs   = uc*sig_;
xs     = 1;
subsidy=0;
qx=q;
Rreal=(R+1)/(1+pi);
Rnominal=R+1;
Infl=1+pi;
end;


shocks;
// Efficient shocks
var E_A; stderr 1;
var E_B; stderr 1;
var E_G; stderr 1;
var E_I; stderr 1;


// Deactivated shocks
//var E_BB; stderr 0;
//var E_Z; stderr 0;
var E_Q; stderr 0;
var E_L; stderr 0;
var E_M; stderr 0;
var E_W1; stderr 0;
var E_XI; stderr 0;


// Inefficient shocks

var E_P; stderr 1;
var E_W; stderr 1;

//Monetary Policy shocks

var E_R; stderr 1;

end;

//resid(1);
steady(solve_algo=0);
resid(1);
check;
model_diagnostics;


//stoch_simul(order=1,irf=5, irf_shocks=(E_R)) Y C R pi q k K L ;
//break;

estimated_params;
sigma_A, , , ,uniform_PDF,0,1;
sigma_B, , , ,uniform_PDF,0,10;
sigma_G, , , ,uniform_PDF,0,10;
sigma_I, , , ,uniform_PDF,0,10;
sigma_P, , , ,uniform_PDF,0,1;
sigma_R, , , ,uniform_PDF,0,1;
sigma_W, , , ,uniform_PDF,0,1;

rho_r, , , ,beta_PDF,0.5,0.2;
rho_w, , , ,beta_PDF,0.5,0.2;
rho_a, , , ,beta_PDF,0.5,0.2;
rho_b, , , ,beta_PDF,0.5,0.2;
rho_g, , , ,beta_PDF,0.5,0.2;
rho_p, , , ,beta_PDF,0.5,0.2;
rho_i, , , ,beta_PDF,0.5,0.2;
phi_i, , , ,NORMAL_PDF,4,1.5;
sig_c, , , ,gamma_PDF,1.5,0.375;
h, , , ,NORMAL_PDF,0.7,0.1;
xi_w, , , ,beta_PDF,0.5,0.1;
sig_l, , , ,gamma_PDF,2,0.75;
xi_p, , , ,beta_PDF,0.5,0.1;
gamma_w, , , ,beta_PDF,0.5,0.15;
gamma_p, , , ,beta_PDF,0.5,0.15;

corGA, , , , uniform_PDF,,,0,10;
ma_p, , , ,beta_PDF,0.5,0.2;
ma_w, , , ,beta_PDF,0.5,0.2;
alph, , , ,NORMAL_PDF,0.3,0.05;
mup, , , ,NORMAL_PDF,1.25,0.12;
ctrend, , , ,NORMAL_PDF,0.4,0.1;
lbar, , , ,NORMAL_PDF,0,2;
betta_rate, , , , NORMAL_PDF,0.25,0.1;
pbar, , , , gamma_PDF,0.62,0.1;
r_pie_est, , , ,NORMAL_PDF,1.5,0.25;
rho, , , ,beta_PDF,0.75,0.1;
r_y_est, , , ,NORMAL_PDF,0.12,0.05;
xiparam, , , ,NORMAL_PDF,0.015,0.01;
qt, , , ,NORMAL_PDF,0.985,0.1;
scrap, , , ,NORMAL_PDF,0.5,0.1;
kt, , , ,NORMAL_PDF,0.2,0.05;
//sigma_M, , , ,uniform_PDF,(10+0)/2,((10-0)^2/12)^(.5);
//sigma_L, , , ,uniform_PDF,(10+0)/2,((10-0)^2/12)^(.5);
//rho_l, , , ,beta_PDF,0.5,0.2;
//sigma_Q, , , ,uniform_PDF,(10+0)/2,((10-0)^2/12)^(.5);
//rho_q, , , ,beta_PDF,0.5,0.2;
//sigma_W1, , , ,uniform_PDF,(10+0)/2,((10-0)^2/12)^(.5);
//rho_W1, , , ,beta_PDF,0.5,0.2;
//sigma_xi, , , ,uniform_PDF,(10+0)/2,((10-0)^2/12)^(.5);
//rho_xi, , , ,beta_PDF,0.5,0.2;

end;

estimated_params_init;				
alph      	,	0.192344926987021	;
phi_i     	,	6.17065937456949	;
sig_c     	,	1.94661944905612	;
h         	,	0.729298687040132	;
gamma_w   	,	0.545390891363723	;
xi_w      	,	0.816432939413862	;
gamma_p   	,	0.227049313444297	;
xi_p      	,	0.573420023033146	;
sig_l     	,	2.00979927681765	;
rho       	,	0.836182227351902	;
rho_a     	,	0.949309043462200	;
rho_b     	,	0.176201353456767	;
rho_g     	,	0.982480488345660	;
rho_i     	,	0.653550529381114	;
mup       	,	1.48427616617941	;
pbar      	,	0.622583596378731	;
rho_p     	,	0.968083278500972	;
rho_w     	,	0.909564205153107	;
rho_r     	,	0.622297577769036	;
ma_p      	,	0.622075877837990	;
ma_w      	,	0.981964530655509	;
corGA     	,	2.25559860762065	;
ctrend    	,	0.450448066420906	;
lbar      	,	0.370562828724896	;
betta_rate	,	0.393829963583098	;
xiparam   	,	0.0156792620938824	;
kt        	,	0.185634662843970	;
qt        	,	0.987981254011238	;
scrap     	,	0.476777672936394	;
r_pie_est 	,	1.74667619803870	;
r_y_est   	,	0.0121583854170700	;
sigma_A   	,	0.373537043123849	;
sigma_B   	,	2.79467408929443	;
sigma_G   	,	2.12867630115551	;
sigma_I   	,	4.45866232136064	;
sigma_P   	,	0.0965368928140807	;
sigma_W   	,	0.475103042523399	;
sigma_R   	,	0.0987880932079133	;
end;



varobs dYobs dCobs dIobs Lobs dWobs PIEobs Robs ; 

options_.pruning=1;
//estimation(datafile=USDATA_Steph_8807_detrendk,mh_jscale=0.3,mh_replic =1300,mode_compute=4, moments_varendo, graph_format = PDF ) dYobs dCobs dIobs Lobs dWobs PIEobs Robs kobs q k y C I;
estimation(order=2,bayesian_irf, irf=20, datafile=DataUSobstot,first_obs=100,mh_jscale=0.3,mh_replic =1300,plot_priors=0) dYobs dCobs dIobs Lobs dWobs PIEobs Robs q k C I Y L K;
%mode_compute=0,mode_file=EST_LEV_XIshock_8807old51_mode
%for i=1:length(M_.param_names);parname=strtrim(M_.param_names(i,:)); eval(sprintf(' if exist(''%s'');set_param_value(''%s'',%s);end',parname,parname,parname));end
